#include "getwww.h"


/****************************************************************************************************/

int Check::Exist(char *www_file_orig)
{
  
  strcpy (www_file, www_file_orig);
  www_scan_path (www_file, WWW_LOCAL);

  if (stat (www_file, &test) != -1)
    {
      if (test.st_size == 0)
	{
	  unlink (www_file);
	  return (0);
	}
      if (test.st_size < PARSE_STRING_MAX)
	{
	  int i;
	  test_file = fopen (www_file, "rb");
	  for (i = 0; !feof (test_file); i++)
	    file_content[i] = fgetc (test_file);
	  file_content[i] = NULL_CHAR;
	  fclose (test_file);
	  for (i = 0; file_content[i]; i++)
	    {
	      if (!strncasecmp (&file_content[i], error_msg, strlen (error_msg)))
		{
		  unlink (www_file);
		  file_error = fopen (FILE_ERROR, "a+b");
		  fprintf (file_error, "%s : %s\n", www_file, "404 error file exist in hard disk");
		  fclose (file_error);
		  return (0);
		}
	    }
	}
      return (1);
    }
  return (0);
}

/****************************************************************************************************/
int Check::New (char *www_file_orig)
{

  strcpy (www_file, www_file_orig);

  if ((exist = fopen (FILE_ERROR, "rb")) != NULL_CHAR)
    {
      for (int i = 0; !feof (exist); i++)
	{
	  exist_file[i] = fgetc (exist);
	  if (exist_file[i] == ' ' || feof (exist))
	    {
	      exist_file[i] = NULL_CHAR;
	      if (!strcmp (www_file, exist_file))
		{
		  fclose (exist);
		  return (1);
		}
	      for (; exist_file[i] != '\n' && !feof (exist);)
		exist_file[i] = fgetc (exist);
	      i = -1;
	    }
	}
      fclose (exist);
    }

  www_scan_path (www_file, WWW_LOCAL);

  if ((exist = fopen (FILE_SCAN, "rb")) != NULL_CHAR)
    {
      for (int i = 0; !feof (exist); i++)
	{
	  exist_file[i] = fgetc (exist);
	  if (exist_file[i] == '\n' || feof (exist))
	    {
	      exist_file[i] = NULL_CHAR;
	      if (!strcmp (www_file, exist_file))
		{
		  fclose (exist);
		  return (1);
		}
	      i = -1;
	    }
	}
      fclose (exist);
    }
  return (0);
}


/****************************************************************************************************/
// ȭ Ȯڸ ˻ؼ ̳ʸ ȭ ǴѴ 

int Check::Binary (char *www_file)
{
  static char *EXT[] =
  {".arj", ".lzh", ".rar", ".gz", ".tar", ".tgz", ".tar.gz", ".zip",
   ".gif", ".jpg", "jpeg", ".png", ".xbm", ".xpm",
   ".au", ".mid", ".mp3", ".ram", ".wav",
   ".avi", ".mpeg", ".mpg",
   "\0"};
  int i=0;
  int j = strlen (www_file);
  for (; *EXT[i]; i++)
    if (j > strlen (EXT[i]) && !strcasecmp (&www_file[j - strlen (EXT[i])], EXT[i]))
      return (1);
  return (0);
}

/****************************************************************************************************/
int Check::Want (char *www_file_orig)
{
  int only_get_match_string = 1;
  int only_get_dir=1;
  int only_get_match_ext=1;

  char *p;

  strcpy (www_file, www_file_orig);
  www_scan_path (www_file, WWW_LOCAL);

  for (int i = 0; i<is_want_count; i++)
    {
      p=&IS_WANT[i][1];
      if (IS_WANT[i][0] == '&')
	{
	  if (strlen (p-1) == 3 && *p == '.' && *(p+1) == '/')
	    {
	      int j = 0;
	      for (; www_file[j] != '/' && www_file[j]; j++)
		;
	      if (www_file[j] == NULL_CHAR)
		return (1);
	    }
	  else if (!strncmp (www_file, p, strlen (p))) /* -D  don't get dir */
	    return (1);
	}
      else if (IS_WANT[i][0] == '%' &&	/* -T don't get match extension */
	       !strncmp (&www_file[strlen (www_file) - strlen (p)], p, strlen (p)))
	return (1);
      else if (IS_WANT[i][0] == '#')	/* -S don't get match string  */
	{
	  int j;
	  for (j = strlen (www_file) - 1; www_file[j] != '/' && j > 0; j--)
	    ;
	  for (; j < strlen (www_file); j++)
	    if (!strncmp (&www_file[j], p, strlen (p)))
	      return (1);
	}
      else if (IS_WANT[i][0] == '?' && only_get_match_string != 2)	/* -s only get match string  */
	{
	  int j;
	    only_get_match_string=0;
	  for (j = strlen (www_file) - 1; www_file[j] != '/' && j > 0; j--)
	    ;
	  for (; j < strlen (www_file); j++)
	    if (!strncmp (&www_file[j], p, strlen (p)))
	      {
		only_get_match_string = 2;
		break;
	      }
	}
      else if (IS_WANT[i][0] == '*' && only_get_dir !=2)	/* -d only get dir */
	{
	  only_get_dir=0;
	  if (strlen (p-1) == 3 && *p == '.' && *(p+1) == '/')
	    {
	      int j;
	      for (j = 0; www_file[j] != '/' && www_file[j]; j++)
		;
	      if (www_file[j] == NULL_CHAR)
		only_get_dir = 2;
	    }
	  else if (!strncmp (www_file, p, strlen (p)))
	    only_get_dir = 2;
	}
      else if (IS_WANT[i][0] == '|' && only_get_match_ext !=2)	/*  -t only get match extension  */
	{
	  only_get_match_ext=0;
	  if (!strncmp (&www_file[strlen (www_file) - strlen (p)], p, strlen (p)))
	    only_get_match_ext = 2;
	}
    }
  if(only_get_dir && only_get_match_ext && only_get_match_string)
    return(0);
  return (1);
}


/****************************************************************************************************/
void Check::Set_is_want(char *www_file)
{
  IS_WANT[is_want_count]=new char[strlen(www_file)+1];
  strcpy(IS_WANT[is_want_count++],www_file);
}















